package com.example.android_29_1_ex1;

import java.io.*;
import java.net.*;

import android.app.*;
import android.content.*;
import android.os.*;
import android.util.*;

public class NetWorkAsyncTask extends AsyncTask<Integer, String, Integer> {

	final static String TAG = "NetWorkAsyncTask";
	Context mContext = null;
	String mAddr;
	ProgressDialog dialog = null;
	
	public NetWorkAsyncTask(Context c, String a) {
		mContext = c;
		mAddr = a;
	}
	
	@Override
	protected void onPreExecute() {
		Log.i(TAG, "onPreExecute()");
		
		dialog = new ProgressDialog(mContext);
		dialog.setProgressStyle(ProgressDialog.STYLE_SPINNER);
		dialog.setTitle("Dialog");
		dialog.setMessage("down...");
		dialog.show();
	}
	
	@Override
	protected Integer doInBackground(Integer... params) {
		Log.i(TAG, "doInBackground()");
		
		StringBuffer sb = new StringBuffer();
		InputStream is = null;
		InputStreamReader isr = null;
		BufferedReader br = null;

		try {
			URL url = new URL(mAddr);
			HttpURLConnection connection = (HttpURLConnection) url.openConnection();
			connection.setConnectTimeout(10000);

			if (connection.getResponseCode() == HttpURLConnection.HTTP_OK) {
				is = connection.getInputStream();
				isr = new InputStreamReader(is);
				br = new BufferedReader(isr);

				while (true) {
					
					String strLine = br.readLine();
					if (strLine == null) break;

					sb.append(strLine + "\n");
				}

				Log.i(TAG, "sb : " + sb.toString());
			}

		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			try {
				if (br != null) br.close();
				if (isr != null) isr.close();
				if (is != null) is.close();
			} catch (Exception e2) {
				e2.printStackTrace();
			}
		}
		
		return null;
	}
	
	@Override
	protected void onProgressUpdate(String... values) {
		Log.i(TAG, "onProgressUpdate()");
		super.onProgressUpdate(values);
	}
	
	@Override
	protected void onPostExecute(Integer result) {
		Log.i(TAG, "onPostExecute()");
		dialog.dismiss();
	}

	@Override
	protected void onCancelled() {
		Log.i(TAG, "onCancelled()");
		super.onCancelled();
	}
	
}
